#include "geo.h"
#include "bgraphic.h"
#include "util.h"

void map_wrap(int wrap)
{
	int x,y;

	if (wrap)
	{
		GraphicsHandler->clreol(0,400);
		GraphicsHandler->printf(LIGHTRED,0,400,"Wrapping");

		for(x=1; x<SIZE2; x++)
		{
			cell[x][0].elev = cell[0][0].elev;
			cell[x][SIZE-1].elev = cell[0][SIZE-1].elev;
		}
		for (y=1; y<SIZE-1; y++)
			cell[SIZE2-1][y].elev = cell[0][y].elev;

		GraphicsHandler->clreol(0,400);
	}
}

void map_smooth()
{
	int x,y,x1,y1;
	CELL2 z;

	GraphicsHandler->clreol (0,400);
	int step = pow(2,GEO_LEVEL-LEVEL);

	for (x=0; x<SIZE2; x+=step)
	{
		if ( (x & 0x000F) == 0)
			GraphicsHandler->printf (LIGHTRED,0,400,"Smooth %3d%%",
				int((long(x)*100)/SIZE2));

		for (y=0; y<SIZE; y+=step)
		{
			z = 0;
	
			for (x1=x-step; x1<=x+step; x1+=step)
				for (y1=y-step; y1<=y+step; y1+=step)
					z += val(x1,y1);

			cell[x][y].elev = z/9;
		}
	}
	GraphicsHandler->clreol (0,400);
	map_wrap(wrap);
}

#if sizeof(CELL)==1
#define ERODE 1
#else
#define ERODE 250
#endif

void erode(int x, int y, int step)
{
	CELL2 z;
	int x1,y1,x2,y2;

	delta(x,y,x1,y1,x2,y2,step);
//	x1 = x-1; x2 = x+1; if (x1<0) x1=SIZE2-2; if (x2>=SIZE2-1) x2=0;
//	y1 = y-1; y2 = y+1; if (y1<0) y1=SIZE-2;  if (y2>=SIZE-1)  y2=0;

	z = cell[x][y].elev;

	if (z < sea)
	{
		if (z < cell[x1][y1].elev) z = cell[x1][y1].elev;
		if (z < cell[x1][y ].elev) z = cell[x1][y ].elev;
		if (z < cell[x1][y2].elev) z = cell[x1][y2].elev;
		if (z < cell[x ][y1].elev) z = cell[x ][y1].elev;
		if (z < cell[x ][y2].elev) z = cell[x ][y2].elev;
		if (z < cell[x2][y1].elev) z = cell[x2][y1].elev;
		if (z < cell[x2][y ].elev) z = cell[x2][y ].elev;
		if (z < cell[x2][y2].elev) z = cell[x2][y2].elev;

		if (z > sea)
		{
			cell[x][y].elev += ERODE;
			if (cell[x][y].elev > z) cell[x][y].elev = z;
		}
	}
	else
	{
		z -= ERODE;

		if (z > cell[x1][y1].elev) z = cell[x1][y1].elev;
		if (z > cell[x1][y ].elev) z = cell[x1][y ].elev;
		if (z > cell[x1][y2].elev) z = cell[x1][y2].elev;
		if (z > cell[x ][y1].elev) z = cell[x ][y1].elev;
		if (z > cell[x ][y2].elev) z = cell[x ][y2].elev;
		if (z > cell[x2][y1].elev) z = cell[x2][y1].elev;
		if (z > cell[x2][y ].elev) z = cell[x2][y ].elev;
		if (z > cell[x2][y2].elev) z = cell[x2][y2].elev;

		if (z < cell[x][y].elev)
		{
			z = cell[x][y].elev;
			cell[x][y].elev -= ERODE;
			if (cell[x][y].elev < sea)
				cell[x][y].elev = sea;
		}
	}
}

void map_erode()
{
	int x,y;
	GraphicsHandler->printf (LIGHTRED,0,400,"erode");

	int step = pow(2,GEO_LEVEL-LEVEL);

	for (x=0; x<SIZE2; x+=step)
	{
		if ( (x & 0x000F) == 0)
			GraphicsHandler->printf (LIGHTRED,0,400,"erode %3d%%",
				int((long(x)*100)/SIZE2));

		for (y=0; y<SIZE; y+=step)
			erode(x,y,step);
	}
	GraphicsHandler->clreol (0,400);

	map_wrap(wrap);
}
