#ifndef MAP_H
#define MAP_H

#define MIN_ELEV		0
#define SEA_ELEV	10000
#define MAX_ELEV	30000

#define MAP_SIZE	64

#define WORLD		1
#define REGIONAL	2
#define LOCAL		3
#define INDOOR		4
#define OUTDOOR		5

class MapCell {
friend Map;
protected:
	int		elevation;				// elevation:		10000 = sea level
	int		water_level;

	char	precip;
	int		runoff;
	char	water;				// 0=dry	1=standing	2=running

public:
				MapCell ();
};

class Map {
protected:
	char		map_type;
	MapCell **	cell;

public:
				Map (int);

	void		generate ();
};

#endif